package com.sa.ibiz.demo.demo.mapper;

import java.util.List;
import org.apache.ibatis.annotations.Param;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import com.sa.ibiz.demo.demo.domain.CodeItem;
import com.sa.ibiz.demo.demo.service.dto.CodeItemSearchFilter;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
public interface CodeItemMapper extends BaseMapper<CodeItem>{
    @CacheEvict( value="entity",key = "'CodeItem:'+#p0.codeitemid")
    void updateOne(@Param("codeitem") CodeItem codeitem);
    List<CodeItem> searchDefault(@Param("srf") CodeItemSearchFilter searchfilter,@Param("ew") Wrapper<CodeItem> wrapper) ;
    Page<CodeItem> searchDefault(IPage page, @Param("srf") CodeItemSearchFilter searchfilter, @Param("ew") Wrapper<CodeItem> wrapper) ;
    List<CodeItem> searchCurCL(@Param("srf") CodeItemSearchFilter searchfilter,@Param("ew") Wrapper<CodeItem> wrapper) ;
    Page<CodeItem> searchCurCL(IPage page, @Param("srf") CodeItemSearchFilter searchfilter, @Param("ew") Wrapper<CodeItem> wrapper) ;
    @Select("${sql}")
    List<Map<String,Object>> selectRow( @Param("sql")String sql);
    @Override
    @Cacheable( value="entity",key = "'CodeItem:'+#p0")
    CodeItem selectById(Serializable id);
    @Override
    @CacheEvict( value="entity",key = "'CodeItem:'+#p0.codeitemid")
    int updateById(@Param(Constants.ENTITY) CodeItem entity);
    @Override
    @CacheEvict( value="entity",key = "'CodeItem:'+#p0.codeitemid")
    int insert(CodeItem entity);
    @Override
    @CacheEvict( value="entity",key = "'CodeItem:'+#p0")
    int deleteById(Serializable id);
}